﻿Imports System.Windows.Interactivity
Imports Telerik.Windows.Controls

Public Class TransferVisualStates
	Inherits Behavior(Of Control)

	Private Sub ChangeCurrentState()
		Dim ancestor = Me.AssociatedObject.ParentOfType(Of RadTabItem)()
		If ancestor IsNot Nothing Then
			If VisualTreeHelper.GetChildrenCount(ancestor) > 0 Then
				Dim firstPanel = TryCast(VisualTreeHelper.GetChild(ancestor, 0), FrameworkElement)
				If firstPanel IsNot Nothing Then
					Dim groups = VisualStateManager.GetVisualStateGroups(firstPanel)
					For Each group As VisualStateGroup In groups
						AddHandler group.CurrentStateChanged, AddressOf group_CurrentStateChanged
					Next
				End If
			End If
		End If
	End Sub

	Protected Overrides Sub OnAttached()
		MyBase.OnAttached()
		Me.Dispatcher.BeginInvoke(New Action(AddressOf ChangeCurrentState))
	End Sub

	Private Sub group_CurrentStateChanged(ByVal sender As Object, ByVal e As VisualStateChangedEventArgs)
		VisualStateManager.GoToState(Me.AssociatedObject, e.NewState.Name, True)
	End Sub

	Protected Overrides Sub OnDetaching()
		'you may want to unregister from the events here
		MyBase.OnDetaching()
	End Sub
End Class
